/*
 *	    ____  ____  _____   ____________
 *	   / __ / __ /  _/ | / /_  __/ __
 *	  / /_/ / /_/ // //  |/ / / / / /_/ /
 *	 / ____/ _, _// // /|  / / / / _, _/
 *	/_/   /_/ |_/___/_/ |_/ /_/ /_/ |_|
 *
 */

/*
 *	Formide App Project definition
 */

var fs 		= require('fs');
var	path	= require('path');

module.exports = {

	// static
	PROJECT_FILE: 'formide.project',
	PROJECT_DEFAULT:
	{
		"name": "",
		"version": "1.0.0",
		"identifier": "",
	    "properties":
	    {
	    	"assets": false,
	        "plugin": false,
	        "config": false
	    },
	    "dependencies":
	    {
	    	"formideViewer": "latest"
	    }
	},

	// functions
	load: function()
	{
		this.file = this.PROJECT_FILE;

		if( fs.existsSync( this.file ) )
		{
			try
			{
				this.data = JSON.parse( fs.readFileSync( this.file ) );
				return this;
			}
			catch( e )
			{
				throw new Error( 'There was an error loading your '+this.PROJECT_FILE+' file: ' + e.message );
			}
		}
		else
		{
			throw new Error( 'The '+this.PROJECT_FILE+' file was not found. Run this command in the correct directory' );
		}
	},

	create: function( name )
	{
		this.data = this.PROJECT_DEFAULT;
		return this;
	},

	get: function( k )
	{
		if( !this.data )
		{
			return null;
		}

		if( k )
		{
			return this.data[k];
		}
		else
		{
			return this.data;
		}
	},

	set: function( k, v )
	{

	}
};